precision highp float;
attribute vec3 a_Position;
attribute vec2 a_TextureCoordinate;
attribute vec2 a_TextureCoordinate1;
attribute vec3 a_Normal;
	attribute vec4 a_Color;
uniform mat4 u_MVPMatrix;
uniform mat4 u_MMatrix;
uniform vec3 u_CameraWorldPosition;
uniform mediump vec3 LightBDirUP;
uniform mediump vec3 LightBDirDOWN;
uniform mediump vec3 LightADir;
uniform lowp vec3 diffColor;
uniform lowp vec3 LightColB;
const lowp float Glossiness_Spec = float(3.500000); // const-optimized by shader optimizer!
const lowp float u_Opacity = float(1.000000); // const-optimized by shader optimizer!
const lowp float u_LightDir = float(0.000000); // const-optimized by shader optimizer!
	const lowp float u_CCM = float(0.000000); // const-optimized by shader optimizer!
	const lowp float u_TCO = float(0.000000); // const-optimized by shader optimizer!
	const lowp float u_EFF = float(0.000000); // const-optimized by shader optimizer!
	const lowp float u_TRA = float(0.000000); // const-optimized by shader optimizer!
	varying mediump vec3 v_Refl;
varying mediump vec4 varCoordUVColRG;
varying mediump vec3 v_BaseShade;
		varying lowp vec3 glasscol;
float trowbridgeReitz( float NdH, float roughness) {
	float result = (1. / (1. + (1. - (NdH*NdH)) * roughness));
	result *= result;
	return result;
}
#define GAMMA_INV 0.45
#define GAMMA 2.2
vec3 Degamma( vec3 color ) {
	return pow( color, vec3(GAMMA_INV));
}
vec3 DegammaOpt( vec3 color ) {
	vec3 A = log2(color)*0.5;
	vec3 result = vec3(0.);
	result.x = exp2(A.x);
	result.y = exp2(A.y);
	result.z = exp2(A.z);
	return result;
}
vec3 EuclidianToSpherical(vec3 vector) {
    return vec3( atan( vector.x, vector.y )/(3.14*2.), - acos( vector.z )/3.14, 0. );
}
float fresnelSchlickIOR23(float NdV) {
    return 0.155188246 + 0.844811753 * exp2((-5.55473 * NdV - 6.98316) * NdV);
}
float fresnelSchlickIOR(float NdV, float ior) {
	float kr = (ior-1.0)/(ior+1.0);
	kr *= kr;
	return kr + (1.0-kr) * pow(1.0-NdV,5.);
}
void main(void) {
    gl_Position = u_MVPMatrix * vec4(a_Position, 1.);
    vec3 worldpos = vec4(u_MMatrix * vec4(a_Position,1.)).xyz;
	vec3 eyeTopos = normalize(u_CameraWorldPosition.xyz-worldpos);
			vec3 normal = vec4(u_MMatrix * vec4(a_Normal,0.)).xyz;
    varCoordUVColRG.xy = a_TextureCoordinate.xy;
	float NdotE = dot(eyeTopos.xyz,normal);
		varCoordUVColRG.w = (a_Color.b * u_EFF) + ( a_Color.g * u_CCM) + (0.8 * u_TCO) + (1. * u_TRA);
		float transpMix = u_CCM + u_EFF + u_TCO + u_TRA;
		varCoordUVColRG.w = mix(1.,varCoordUVColRG.w, transpMix );
		varCoordUVColRG.z = 1.;
		vec3 v_Light;
		vec3 v_Light2;
		vec3 v_Light3;
		vec3 v_Light4;
		v_BaseShade = vec3(0.);
		v_Light = (LightADir);
		v_Light.x *= u_LightDir;
		vec3 half1 = eyeTopos.xyz+v_Light;
		half1 = normalize( half1 );
	v_Refl.xyz = vec3(0.,0.,0.);
			v_BaseShade = diffColor;
	float fresnel = 0.5;
		v_BaseShade.xyz *= (1. - fresnel);
		v_BaseShade.xyz *= a_Color.xyz;
		v_Refl.xyz = reflect(eyeTopos.xyz, normal);
				v_Refl.x = 0.5 + ((-u_TRA)+(-u_EFF)+u_CCM)*0.5;
			v_Refl.y = clamp((0.5 * -v_Refl.z)+0.5,0.,1.);
			glasscol = a_Color.xyz;
	varCoordUVColRG.w *= u_Opacity;
}