precision highp float;
attribute vec3 a_Position;
attribute vec2 a_TextureCoordinate;
attribute vec3 a_Normal;
attribute vec3 a_Tangent;
attribute vec3 a_Binormal;
attribute vec4 a_Color;
uniform mat4 u_MVPMatrix;
uniform mat4 u_MMatrix;
const float lamp1 = float(0.000000); // const-optimized by shader optimizer!
const float lamp2 = float(0.000000); // const-optimized by shader optimizer!
const float indicator = float(0.000000); // const-optimized by shader optimizer!
varying vec2 varCoord;
varying vec3 normal;
	varying vec3 tangent, binormal;
varying vec3 worldpos2;
varying vec4 col;
void main(void) {
    gl_Position = u_MVPMatrix * vec4(a_Position, 1);
    worldpos2 = vec4(u_MMatrix * vec4(a_Position,1.)).xyz;
    normal.xyz = vec4(u_MMatrix * vec4(a_Normal,0.)).xyz;
    tangent.xyz = vec4(u_MMatrix * vec4(a_Tangent,0.)).xyz;
    binormal.xyz = vec4(u_MMatrix * vec4(a_Binormal,0.)).xyz;
    varCoord = a_TextureCoordinate;
	col.r = a_Color.r * indicator;
	col.g = a_Color.g * lamp2;
	col.b = a_Color.b * lamp1;
	col.gb *= vec2(0.75);
	col.gb += vec2(0.25);
	col.w = a_Color.a ;
}