precision highp float;
attribute vec3 a_Position;
attribute vec2 a_TextureCoordinate;
attribute vec3 a_Normal;
attribute vec3 a_Tangent;
attribute vec3 a_Binormal;
uniform mat4 u_MVPMatrix;
uniform mat4 u_MMatrix;
uniform vec3 u_CameraWorldPosition;
varying vec2 varCoord;
varying vec3 normal, lightDir, eyeVec, tangent, binormal;
varying vec3 worldpos2;
void main(void) {
	gl_Position = u_MVPMatrix * vec4(a_Position, 1);
	vec3 eyepos = u_MVPMatrix[3].xyz;
    normal.xyz = vec4(u_MMatrix* vec4(a_Normal.xyz,0.)).xyz;
    tangent.xyz = vec4(u_MMatrix* vec4(a_Tangent.xyz,0.)).xyz;
    binormal.xyz = vec4(u_MMatrix* vec4(a_Binormal.xyz,0.)).xyz;
	lightDir = u_CameraWorldPosition.xyz;
	eyeVec.xyz = (u_CameraWorldPosition );
	worldpos2 = vec4(u_MMatrix * vec4(a_Position,1.)).xyz;
	varCoord = a_TextureCoordinate;
}